/*============================================================================
  File:     HackAttachLogBackup.sql

  Summary:  Hack-attach log tail backup demo.

  Date:     March 2011

  SQL Server Versions:
		10.0.2531.00 (SS2008 SP1)
		9.00.4035.00 (SS2005 SP3)
------------------------------------------------------------------------------
  Written by Paul S. Randal, SQLskills.com

  (c) 2011, SQLskills.com. All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  You may alter this code for your own *non-commercial* purposes. You may
  republish altered code as long as you include this copyright and give due
  credit, but you must obtain prior permission before blogging this code.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

-- Turn on the tracking trace flags
DBCC TRACEON (3004);
DBCC TRACEON (3014)
DBCC TRACEON (3605);
GO

EXEC sp_cycle_errorlog;
GO

DROP DATABASE foo;
GO

-- Do the full restore
RESTORE DATABASE foo FROM
DISK = 'D:\SQLskills\foo.bck';
GO

-- Look in the log, and at Messages
EXEC xp_readerrorlog;
GO

-- Again - but interrupted...
-- Kill after 3 seconds
DROP DATABASE foo;
GO

RESTORE DATABASE foo FROM
DISK = 'D:\SQLskills\foo.bck'
WITH REPLACE;
GO


-- Now watch for the checkpoint file
-- in instance\Backup
RESTORE DATABASE foo FROM
DISK = 'D:\SQLskills\foo.bck';
GO


-- Now use WITH RESTART
EXEC sp_cycle_errorlog;
GO
RESTORE DATABASE foo FROM
DISK = 'D:\SQLskills\foo.bck'
WITH RESTART;
GO

EXEC xp_readerrorlog;
GO